import { AfterViewInit, ElementRef, EventEmitter, OnDestroy } from '@angular/core';
import { TaskManager, TaskManagerService } from '../task-manager.service';
import * as i0 from "@angular/core";
export declare class TaskManagerActionCancelDirective {
    readonly elementRef: ElementRef;
    onClick: EventEmitter<void>;
    constructor(elementRef: ElementRef);
    onClickListener(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaskManagerActionCancelDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TaskManagerActionCancelDirective, "[app-task-manager-action-cancel]", never, {}, { "onClick": "onClick"; }, never>;
}
export declare class TaskManagerActionExecDirective {
    onClick: EventEmitter<void>;
    constructor();
    onClickListener(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaskManagerActionExecDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TaskManagerActionExecDirective, "[app-task-manager-action-exec]", never, {}, { "onClick": "onClick"; }, never>;
}
export declare class TaskManagerRunningComponent {
    taskManager: TaskManagerService;
    /** Template inside the MatTab view that contains an `<ng-content>`. */
    context: any;
    constructor(taskManager: TaskManagerService);
    static ɵfac: i0.ɵɵFactoryDeclaration<TaskManagerRunningComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TaskManagerRunningComponent, "app-task-manager-running", never, { "context": "context"; }, {}, never, ["*"]>;
}
export declare class TaskManagerDelayedComponent {
    taskManager: TaskManagerService;
    /** Template inside the MatTab view that contains an `<ng-content>`. */
    context: any;
    constructor(taskManager: TaskManagerService);
    cancelTask(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaskManagerDelayedComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TaskManagerDelayedComponent, "app-task-manager-delayed", never, { "context": "context"; }, {}, never, ["*"]>;
}
export declare class TaskManagerActionComponent {
    taskManager: TaskManagerService;
    context: any;
    /** Template inside the MatTab view that contains an `<ng-content>`. */
    constructor(taskManager: TaskManagerService);
    performTask(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaskManagerActionComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TaskManagerActionComponent, "app-task-manager-action", never, { "context": "context"; }, {}, never, ["*"]>;
}
export declare class TaskManagerComponent implements AfterViewInit, OnDestroy {
    taskManager: TaskManagerService;
    taskContainer?: TaskManager.TaskContainer;
    set task(taskContainerOrString: TaskManager.TaskContainer | string);
    get taskId(): string | undefined;
    cancelDirective?: TaskManagerActionCancelDirective;
    execDirective?: TaskManagerActionCancelDirective;
    constructor(taskManager: TaskManagerService);
    get loading(): boolean;
    get taskState(): TaskManager.TaskState | undefined;
    get actionTemplateContext(): {
        $implicit: any;
    };
    get delayedTemplateContext(): {
        $implicit: any;
    };
    private _createContext;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    cancelTask(): void;
    explainDelayReason(): "Waiting for user login" | "Waiting for Tap reconnection" | "Unknown reason" | undefined;
    execTask(context?: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaskManagerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TaskManagerComponent, "app-task-manager", never, { "task": "task"; }, {}, ["cancelDirective", "execDirective"], ["app-task-manager-delayed", "app-task-manager-running", "app-task-manager-action"]>;
}
